

// глобальные переменные для работы с ними в программе
int ds_int; // интервал замера ds18b20 в секундах 
int mqtt_int; // интервал отправки данных по MQTT в секундах 
float tem; // тут храним температуру
float p_tem; // температура включения реле
float h_tem; // гистерезис
String mode; // режим работы по температуре/ручной ("TEM"/"MAN")

void parameters(){
// создаем параметры для нашего проекта
  jee.var("wifi", "STA"); // режим работы WiFi по умолчанию ("STA" или "AP")  (параметр в энергонезависимой памяти)
  jee.var("ssid", "ИМЯ ВАШЕЙ ТОЧКИ ДОСТУПА"); // имя точки доступа к которой подключаемся (параметр в энергонезависимой памяти)
  jee.var("pass", "ПАРОЛЬ ТОЧКИ ДОСТУПА"); // пароль точки доступа к которой подключаемся (параметр в энергонезависимой памяти)

  jee.var("p_tem", "20");  // температура включения реле
  jee.var("h_tem", "2"); // гистерезис
  jee.var("ds_int", "10"); // это будет интервал замеров DH22 в секундах
  jee.var("mode", "MAN"); // по заводской настройке работаем вручную ("TEM"/"MAN")
}

void relayState(int pin, bool state, String id);

void update(){ // функция выполняется после ввода данных в веб интерфейсе. получение параметров из веб интерфейса в переменные
  // получаем данные в переменную в ОЗУ для дальнейшей работы
  ds_int = jee.param("ds_int").toInt(); // читаем параметр в переменную с переобразованием в нужный тип данных
	p_tem = jee.param("p_tem").toFloat(); // читаем параметр в переменную с переобразованием в нужный тип данных
  h_tem = jee.param("h_tem").toFloat(); // читаем параметр в переменную с переобразованием в нужный тип данных
  mode = jee.param("mode"); // читаем параметр в переменную как String

  if (mode == "MAN"){ // обеспечиваем ручную работу реле
    if (jee.param("relay") == "true"){
      relayState(RELAY, true, "relay");
    }
    else { 
      relayState(RELAY, false, "relay");
    }
  }
}

void interface(){ // функция в которой мы формируем веб интерфейс и интерфейс в приложении JeeUI2

  jee.app("Теплый пол на балконе"); // название программы (отображается в веб интерфейсе)

  // создаем меню
  jee.menu("Устройство");
  jee.menu("Настройки MQTT");
  jee.menu("Настройки Wi-Fi");
  // создаем контент для каждого пункта меню

  jee.page(); // разделитель между страницами
  // Страница "Датчик"

  // эта суперфункция покажет в веб интерфейсе температуру 
  // и она же обепечит автоматическую отправку по mqtt по 
  // одноименному топику при обновлении параметра (первый аргумент)
  // как только вы запишите в "tem" значение - туту же 
  // отправится сообщение на топик ID/tem с заданным значением вот так: jee.var("tem", "значение")
  jee.pub("tem", "Температура", "°C", "#6060ff", "#f5f5f5"); 

  
  jee.checkbox("relay", "Реле"); // Это переключатель, чтобы щелкать релющкой вручную
	jee.range("p_tem", -10, 30, .5, "Порог температуры"); // ползунок с заданными минимальными и максимальными значениями и шагом
  jee.range("h_tem", 0, 5, .1, "Гистерезис");  // ползунок с заданными минимальными и максимальными значениями и шагом

  jee.option("TEM", "Термостат"); // опция для элемента селекта
  jee.option("MAN", "Ручной"); // опция для элемента селекта
  jee.select("mode", "Режим работы устройства"); // Собственно сам элемент селект

  jee.number("ds_int", "Интервал опроса датчика сек.");

  jee.page(); // разделитель между страницами
  // Страница "Настройки MQTT"
  jee.formMqtt(); // готовая форма настроек MQTT

  jee.page(); // разделитель между страницами
  // Страница "Настройки WiFi"
  jee.formWifi(); // готовая форма настроек Wi-Fi
  jee.page(); // разделитель между страницами

}
